import java.applet.Applet;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;


public class cXO extends Applet implements MouseListener {

public int t[][]; // tabla
public int k = 1; // ko je na potezu
public int d = 0; // dubina igre
private Rectangle Cell = new Rectangle(0,0, 80, 80);
private Graphics bufferg;
private Image buffer, ix, io;


public void init()
{
  setBackground(new Color(255, 255, 255));
  buffer    = createImage(getSize().width, getSize().height);
  bufferg   = buffer.getGraphics();
  addMouseListener(this);
  t = new int[3][3];
  for (int i=0; i<3; i++)
     for (int j=0; j<3; j++)
          t[i][j]=0;
  k=-1; d=0;

  ix    = getImage(getDocumentBase(), "x.gif");
  io    = getImage(getDocumentBase(), "o.gif");
  odigraj();
  repaint();
}

public void drawWinLine(Graphics g)
{
  Rectangle WC = new Rectangle(0,0, 0, 0);
  int w = Cell.width, h = Cell.height;
  for (int aP = -1; aP<2; aP = aP + 2)
    for (int i = 0; i < 3; i++)
    {
      if ( (t[i][0] == aP) && (t[i][1] == aP) && (t[i][2] == aP)) WC = new Rectangle((w*i) + (w/2), 0, (w*i) + (w/2), (h*3));
      if ( (t[0][i] == aP) && (t[1][i] == aP) && (t[2][i] == aP)) WC = new Rectangle(0, (h*i) + (h/2), (w*3) , (h*i) + (h/2));
      if ( (t[0][0] == aP) && (t[1][1] == aP) && (t[2][2] == aP)) WC = new Rectangle(0, 0, w*3, h*3);
      if ( (t[2][0] == aP) && (t[1][1] == aP) && (t[0][2] == aP)) WC = new Rectangle(0, w*3, 0, h*3);
    }

  if ( (WC.width != 0) || (WC.height != 0) )
    bufferg.drawLine(WC.x, WC.y, WC.width, WC.height);
}

public void paint(Graphics g)
{
  bufferg.setColor(new Color(255, 255, 255) );
  bufferg.fillRect(0,0, getSize().width, getSize().height);
  bufferg.setColor(new Color(0, 0, 0));

  for (int i=1; i<3; i++)
  {
    bufferg.drawLine(0, Cell.height * i, (Cell.width * 3),  Cell.height * i);
    bufferg.drawLine(Cell.width * i, 0, Cell.width * i,  Cell.height * 3);
  }

  for (int i=0; i<3; i++)
    for (int j=0; j<3; j++)
      switch (t[i][j])
      {
        case 1:
          bufferg.drawImage(ix, ( i * Cell.width + ( (Cell.width - ix.getWidth(this) ) / 2)) , (j * Cell.height + ( (Cell.height - ix.getHeight(this)) / 2)), this );
          break;
        case -1:
          bufferg.drawImage(io, ( i * Cell.width + ( (Cell.width - io.getWidth(this) ) / 2)) , (j * Cell.height + ( (Cell.height - io.getHeight(this)) / 2)), this );
          break;
      }

  drawWinLine(bufferg);
  g.drawImage(buffer,0,0,this);
}

public int pobednik()
{
  for (int i=0; i<3; i++)
  {
    if ((t[i][0] == 1) && (t[i][1]==1)&& (t[i][2]==1))
            return 1;
    if ((t[0][i] == 1) && (t[1][i]==1)&& (t[2][i]==1))
            return 1;

    if ((t[i][0] == -1) && (t[i][1]==-1)&& (t[i][2]==-1))
            return -1;
    if ((t[0][i] == -1) && (t[1][i]==-1)&& (t[2][i]==-1))
            return -1;
  }

  if ((t[0][0] == 1) && (t[1][1]==1)&& (t[2][2]==1))
    return 1;
  if ((t[2][0] == 1) && (t[1][1]==1)&& (t[0][2]==1))
    return 1;


  if ((t[0][0]==-1) && (t[1][1]==-1)&& (t[2][2]==-1))
    return -1;
  if ((t[2][0]==-1) && (t[1][1]==-1)&& (t[0][2]==-1))
    return -1;

  return 0;
}


public void mouseReleased (MouseEvent e){}
public void mouseClicked (MouseEvent e){}
public void mouseEntered (MouseEvent e){}
public void mouseExited (MouseEvent e){}

public void mousePressed (MouseEvent e)
{
    int x = e.getX()/Cell.width;
    int y = e.getY()/Cell.height;

    if ((x>2)||(y>2)) return;
    if (t[x][y] != 0) return;
    if ((pobednik() !=0)||(d==9)) return;

    t[x][y]=k;
    k=k*(-1);d++;
    odigraj();
    repaint();
}

//AI :)

public void odigraj(){

	if (pobednik() !=0) return;
	if (d==9) return;


	int nx =0;
	int ny =0; //najbolje x i y

	if (k == -1){
		int v=2; // vrednost pozicije
		int temp;

		for (int i=0; i<3; i++)
			for (int j=0; j<3; j++)
	 			if (t[i][j]==0){
	 				t[i][j]=k; k=k*(-1);d++;
					temp=oceni();
					if (temp<v){
						v=temp;nx=i;ny=j;
					}
					t[i][j]=0; k=k*(-1);d--;
	 			}
	}
	if (k == 1){
		int v=-2; // vrednost pozicije
		int temp;

		for (int i=0; i<3; i++)
			for (int j=0; j<3; j++)
				if (t[i][j]==0){
					t[i][j]=k; k=k*(-1);d++;
					temp=oceni();
					if (temp>v){
						v=temp;nx=i;ny=j;
					}
					t[i][j]=0; k=k*(-1);d--;
				}
	}


	t[nx][ny] = k;
	k=k*(-1);
	d++;
}

public int oceni(){

	if(k==1){
		if (pobednik() !=0) return pobednik();
		if (d==9) return pobednik();
		int v=-2;
		int temp;

		for (int i=0; i<3; i++)
			for (int j=0; j<3; j++)
				if (t[i][j]==0){
					t[i][j]=1; k=-1;d++;
					temp=oceni();
					if (temp>v) v=temp;
					t[i][j]=0; k=1;d--;
				}
		return v;
	}

	if(k==-1){
		if (pobednik() !=0) return pobednik();
		if (d==9) return pobednik();
		int v=2;
		int temp;

		for (int i=0; i<3; i++)
			for (int j=0; j<3; j++)
				if (t[i][j]==0){
					t[i][j]=-1; k=1;d++;
					temp=oceni();
					if (temp<v) v=temp;
					t[i][j]=0; k=-1;d--;
				}
		return v;
	}
	return 0;

}

}

